package cn.zlg.www.list;

import java.util.ArrayList;
import cn.zlg.www.ErrData;
import cn.zlg.www.demo.R;
import cn.zlg.www.main.TimeGetter;
import cn.zlg.www.view.ErrItemView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class ErrListViewAdapter extends BaseAdapter {

	private ArrayList<ErrData> mList;
	private LayoutInflater mLayoutInflater;

	public ErrListViewAdapter() {
		super();
		mList = new ArrayList<ErrData>();
	}

	@Override
	public int getCount() {
		// TODO Auto-generated method stub
		return mList.size();
	}

	@Override
	public Object getItem(int arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getItemId(int arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public View getView(int index, View convertview, ViewGroup arg2) {
		// TODO Auto-generated method stub
		ErrItemView errItemView;
		if (null == convertview) {
			errItemView = new ErrItemView();
			convertview = mLayoutInflater.inflate(R.layout.errinfi, null);
			errItemView.textViewIndex = (TextView) convertview
					.findViewById(R.id.textViewErrIndex);
			errItemView.textViewCmd = (TextView) convertview
					.findViewById(R.id.textViewErrCmd);
			errItemView.textViewCount = (TextView) convertview
					.findViewById(R.id.textViewErrCount);
			errItemView.textViewInfo = (TextView) convertview
					.findViewById(R.id.textViewErrInfo);
			errItemView.textViewTime = (TextView) convertview
					.findViewById(R.id.textViewErrTime);
			convertview.setTag(errItemView);
		} else {
			errItemView = (ErrItemView) convertview.getTag();
		}
		ErrData errData = mList.get(index);
		errItemView.textViewIndex.setText(index + 1 + "");
		errItemView.textViewTime.setText(TimeGetter
				.getTimeString(errData.nTime));
		errItemView.textViewCmd.setText(String.format("%02XH",
				errData.nCmdValue));
		errItemView.textViewCount.setText(errData.nCount + "");
		errItemView.textViewInfo.setText(getStatusInfo(errData.nCmdValue));

		return convertview;
	}

	public void setLayoutInflater(LayoutInflater layoutInflater) {
		this.mLayoutInflater = layoutInflater;
	}

	public static String getStatusInfo(byte nCmd) {
		switch (nCmd) {
		case 0x01:
			return "̫ͻҪ";
		case 0x02:
			return "̫ͻѾ";
		case 0x03:
			return "̫ջҪ";
		case 0x04:
			return "̫ջѾ";
		case 0x05:
			return "CANʹ澯";
		case 0x06:
			return "CANմ澯";
		case 0x07:
			return "CANʹ󱻶";
		case 0x08:
			return "CANմ󱻶";
		case 0x09:
			return "CAN";
		case 0x0A:
			return "CAN߹ر";
		case 0x0B:
			return "CAN ٲöʧ";
		case 0x0C:
			return "";
		}
		return "";
	}

	public void clear() {
		// TODO Auto-generated method stub
		mList.clear();
	}

	public synchronized void add(ErrData obj) {
		// TODO Auto-generated method stub
		mList.add(obj);
	}

	public ArrayList<ErrData> getList() {
		return mList;
	}
}
